*****
* FenixVDI unimplemented functions
* Johan Klockars
*****

lattice		equ	1		; 1 - Assemble for DevPac/Lattice

transparent	equ	1		; Fall through?


*****
*
* What about:
* v_font   Lattice manual p260
* v_offset Lattice manual p267
*
*****
	include	"vdi.inc"

*
* Macros
*
	ifne	lattice
	include	"macros.dev"
	else
	include	"macros.tas"
	endc

	text

	xref	redirect

	xdef	nothing
	xdef	v_clswk,v_clrwk,v_updwk
	xdef	vrq_locator,vrq_valuator,vrq_choice,vrq_string,vsin_mode
	xdef	v_contourfill
	xdef	vqin_mode
	xdef	vex_timv,vex_butv,vex_motv,vex_curv
	xdef	vq_mouse,vq_key_s
	xdef	v_cellarray,vq_cellarray
	xdef	vst_name,vst_width,vst_charmap,vst_kern,v_getbitmap_info
	xdef	v_getoutline,vst_scratch
	xdef	vst_error,vst_arbt,vqt_advance,vq_devinfo,v_savecache
	xdef	v_loadcache,v_flushcache,vst_setsize,vst_skew,vqt_cachesize
	xdef	vqt_get_table,vqt_fontheader,vqt_trackkern,vqt_pairkern
	xdef	v_set_app_buff,vq_chcells,vq_exit_cur,v_enter_cur,v_curup
	xdef	v_curdown,v_curright,v_curleft,v_curhome,v_eeos,v_eeol
	xdef	vs_curaddress,v_curtext,v_rvon,v_rvoff,vq_curaddress
	xdef	vq_tabstatus,v_hardcopy,v_dspcur,v_rmcur,v_form_adv
	xdef	v_output_window,v_clear_disp_list,v_bit_image
	xdef	v_pie,v_ellpie,v_rbox,v_rfbox
	xdef	start_unimpl,end_unimpl


start_unimpl:
	dc.b	"Unimplemented functions",0

* xxxx - Standard Trap function
* Unimplemented traps
* Todo: Implement them!

* No known function
nothing:
	bra	redirect

	dc.b	"Physical Workstation"
* Physical workstation manipulation
v_clswk:
v_clrwk:
v_updwk:
	done_return

	dc.b	"Strange IO"
* Strange mouse/keyboard functions
vrq_locator:
vrq_valuator:
vrq_choice:
vrq_string:
vsin_mode:
vqin_mode:
	bra	redirect

	dc.b	"Normal IO",0
* Normal mouse/keyboard functions
vq_mouse:
vq_key_s:
	bra	redirect

	dc.b	"Vector exchange",0
* Vector exchange functions
vex_timv:
vex_butv:
vex_motv:
vex_curv:
	bra	redirect

	dc.b	"Miscellaneous",0
vq_cellarray:
	bra	redirect

	dc.b	"NVDI"
vst_name:
vst_width:
vst_charmap:
vst_kern:
v_getbitmap_info:
v_getoutline:
vst_scratch:
vst_error:
vst_arbt:
vqt_advance:
vq_devinfo:
v_savecache:
v_loadcache:
v_flushcache:
vst_setsize:
vst_skew:
vqt_cachesize:
vqt_get_table:
vqt_fontheader:
vqt_trackkern:
vqt_pairkern:
v_set_app_buff:
	done_return

	dc.b	"Terminal"
vq_chcells:
vq_exit_cur:
v_enter_cur:
v_curup:
v_curdown:
v_curright:
v_curleft:
v_curhome:
vs_curaddress:
v_rvon:
v_rvoff:
vq_curaddress:
vq_tabstatus:
v_hardcopy:
v_dspcur:
v_rmcur:
v_form_adv:
v_output_window:
v_clear_disp_list:
v_bit_image:
	bra	redirect

	dc.b	"Drawing",0
v_contourfill:
v_cellarray:

v_eeos:
v_eeol:
v_curtext:

v_pie:
v_ellpie:
v_rbox:
v_rfbox:
	done_return

end_unimpl:

	end
