#version 3.1;
#declare Gold_Phong = texture {
	pigment { color rgb <1.0,0.84,0.0> }
	normal { ripples 0.5 scale 0.1 }
	finish { phong 1.0 phong_size 5.0 }
}

#declare xmin  = 0;
#declare xmax  = pi;
#declare ymin  = 0;  
#declare ymax  = 6*pi;
#declare xiter = 11;
#declare yiter = 61;
#declare ix    = (xmax-xmin)/(xiter-1.0);
#declare iy    = (ymax-ymin)/(yiter-1.0);
#declare deltax = (xmax-xmin)/((xiter-1.0)*4.0); 
#declare deltay = (ymax-ymin)/((yiter-1.0)*4.0);
#macro point(xx,yy)
    #declare zzz=-yy/18*sin(xx)*cos(yy);
    #declare xxx=yy/18*sin(xx)*sin(yy);
    #declare yyy=yy/18*cos(xx)+yy/6;
#end
#macro surface(xx,yy)
    point(xx,yy)
    #local xn=xxx;
    #local yn=yyy;
    #local zn=zzz;
    #declare xx=xx+deltax;
    point(xx,yy)
    #local xp=xxx;
    #local yp=yyy;
    #local zp=zzz;
    #declare xx=xx-deltax;
    #declare yy=yy+deltay;
    point(xx,yy)
    #local xq=xxx;
    #local yq=yyy;
    #local zq=zzz;
    #declare yy=yy-deltay;
    #local vn=vcross(<xp-xn,yp-yn,zp-zn>,<xq-xn,yq-yn,zq-zn>);
    #declare nn=vnormalize(vn);
    #declare pp=<xn,yn,zn>;
#end
#declare seashell = mesh {
  #declare xx = xmin;    
  #while (xx<xmax)                        //outer loop
    #declare yy = ymin;
    #while (yy<ymax)                      //inner loop
//POINTS
    surface(xx,yy)
    #declare n1=nn;
    #declare p1=pp;

    #declare yy=yy+iy;
    surface(xx,yy)
    #declare n2=nn;
    #declare p2=pp;
    
    #declare xx=xx+ix;
    surface(xx,yy)
    #declare n3=nn;
    #declare p3=pp;
    
    #declare yy=yy-iy;
    surface(xx,yy)
    #declare n4=nn;
    #declare p4=pp;
    
    #declare xx=xx-ix;
#if(!(p1.x=p2.x&p1.y=p2.y&p1.z=p2.z)|(p2.x=p3.x&p2.y=p3.y&p2.z=p3.z)|(p1.x=p3.x&p1.y=p3.y&p1.z=p3.z))
        smooth_triangle {
          p1,n1,
          p2,n2,
          p3,n3
         }
          
#end
#if(!(p1.x=p3.x&p1.y=p3.y&p1.z=p3.z)|(p3.x=p4.x&p3.y=p4.y&p3.z=p4.z)|(p1.x=p4.x&p1.y=p4.y&p1.z=p4.z))
        smooth_triangle{
          p1,n1,  
          p3,n3,   
          p4,n4 
         }
#end

      #declare yy = yy+iy;
   #end                 //inner loop
   #declare xx = xx+ix;
 #end                   //outer loop
 translate <0,-2,0>
 scale 1/2
}

object {
 seashell
 no_shadow
 texture { Gold_Phong }
 rotate <0,36*clock,0>
 }
 
//Lights, camera, action
camera
{ location  < 1, 1.25, -1>
  direction  1*z
  look_at   < 0, 0, 0>
} 

light_source { < 0, 1.25, -1> color rgb 1 }
light_source { < 1, 1.25, -1> color rgb 1 }

object { box{-2,2 inverse} pigment{color rgb 0.8} }
